uab.classes.RangeEffect = uab.mixins.aceOO.Class(uab.interfaces.IUnitEffect)

function uab.classes.RangeEffect.prototype:init()
	uab.classes.RangeEffect.super.prototype.init(self)
end

function uab.classes.RangeEffect.prototype:GetName()
	return "outofrange"
end

function uab.classes.RangeEffect.prototype:GetDisplayName()
	return "Out of Range"
end

function uab.classes.RangeEffect.prototype:GetDefaultHighlightColor()
	return { r = 1,    g = 0.5,  b = 0, a = 1, }
end

function uab.classes.RangeEffect.prototype:IsActive(action, button, unit)
	return not self:UnitInRange(action, button, unit)
end

function uab.classes.RangeEffect.prototype:UnitInRange(action, button, unit)
    if not unit then
        unit = SecureButton_GetModifiedUnit(button:Frame())
    end

	if action and action:GetClassName() == "SpellAction" then
        local spell = action:GetSpellName()
    
        if spell then
            local inRange = IsSpellInRange(spell, unit)
            if inRange then
                if inRange == 1 then
                    return true
                end
                
                return nil
            end
        end
    
        -- check follow distance as the default check (~28 yards)
        return CheckInteractDistance(unit, 4)
    end
    
    return true
end

uab:RegisterUnitEffect(uab.classes.RangeEffect)
